/**
 * @file
 * VuoList_VuoImageColorDepth C type definition.
 *
 * @copyright Copyright © 2012–2015 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoImageColorDepth_H
#define VuoList_VuoImageColorDepth_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoImageColorDepth VuoList_VuoImageColorDepth
 * A list of @ref VuoImageColorDepth elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoImageColorDepth_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoImageColorDepth elements.
 */
typedef const struct VuoList_VuoImageColorDepth_struct { void *l; } * VuoList_VuoImageColorDepth;
/// @}
#endif

/**
 * Creates a new list of @ref VuoImageColorDepth elements.
 */
VuoList_VuoImageColorDepth VuoListCreate_VuoImageColorDepth(void);

/**
 * Makes a shallow copy of `list` — its items are retained (not copied) by the new list.
 */
VuoList_VuoImageColorDepth VuoListCopy_VuoImageColorDepth(const VuoList_VuoImageColorDepth list);

/**
 * Returns the @ref VuoImageColorDepth at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoImageColorDepth VuoListGetValue_VuoImageColorDepth(const VuoList_VuoImageColorDepth list, const unsigned long index);

/**
 * Changes the @ref VuoImageColorDepth at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValue_VuoImageColorDepth(const VuoList_VuoImageColorDepth list, const VuoImageColorDepth value, const unsigned long index);

/**
 * Inserts the `VuoImageColorDepth` immediately before `index`.
 * Index values start at 1.
 * Inserting at index 0 prepends the value to the list.
 * Inserting at an index beyond the last value in the list appends the value to the list.
 */
void VuoListInsertValue_VuoImageColorDepth(const VuoList_VuoImageColorDepth list, const VuoImageColorDepth value, const unsigned long index);

/**
 * Prepends @c value to @c list.
 */
void VuoListPrependValue_VuoImageColorDepth(VuoList_VuoImageColorDepth list, const VuoImageColorDepth value);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoImageColorDepth(VuoList_VuoImageColorDepth list, const VuoImageColorDepth value);

/**
 * Swaps the value at `indexA` with the value at `indexB`.
 */
void VuoListExchangeValues_VuoImageColorDepth(VuoList_VuoImageColorDepth list, const unsigned long indexA, const unsigned long indexB);

/**
 * Generates a random permutation of `list`.
 *
 * `chaos` ranges from 0 to 1.  When `chaos` is 1, a full Fisher–Yates shuffle is performed.  When less than 1, fewer iterations are performed.
 */
void VuoListShuffle_VuoImageColorDepth(VuoList_VuoImageColorDepth list, const double chaos);

/**
 * Reverses the order of the items in `list`.
 */
void VuoListReverse_VuoImageColorDepth(VuoList_VuoImageColorDepth list);

/**
 * Removes items from the list except those in the range specified by `startIndex` and `itemCount`.
 */
void VuoListCut_VuoImageColorDepth(VuoList_VuoImageColorDepth list, const signed long startIndex, const unsigned long itemCount);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoImageColorDepth(VuoList_VuoImageColorDepth list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoImageColorDepth(VuoList_VuoImageColorDepth list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoImageColorDepth(VuoList_VuoImageColorDepth list);

/**
 * Removes the `VuoImageColorDepth` at `index`.
 * Index values start at 1.
 * Attempting to remove index 0 or an index beyond the last value in the list has no effect.
 */
void VuoListRemoveValue_VuoImageColorDepth(VuoList_VuoImageColorDepth list, const unsigned long index);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoImageColorDepth(const VuoList_VuoImageColorDepth list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoImageColorDepth VuoList_VuoImageColorDepth_makeFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoImageColorDepth_getJson(const VuoList_VuoImageColorDepth value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoImageColorDepth_getSummary(const VuoList_VuoImageColorDepth value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoImageColorDepth VuoList_VuoImageColorDepth_makeFromString(const char *str);
char * VuoList_VuoImageColorDepth_getString(const VuoList_VuoImageColorDepth value);
/// @}

/**
 * @}
 */

#endif
